/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.45 from the
 * contents of Core.xs. Do not edit this file, edit Core.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Core.xs"
#ifndef WIN32
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#define USE_MMAP
#endif

#include "EXTERN.h"   /* std perl include */
#include "perl.h"     /* std perl include */
#include "XSUB.h"     /* XSUB include */

#if defined(CONTEXT)
#undef CONTEXT
#endif

#define PDL_CORE      /* For certain ifdefs */
#include "pdl.h"      /* Data structure declarations */
#include "pdlcore.h"  /* Core declarations */

#if BADVAL
#  if !BADVAL_USENAN
#include <float.h>
#  endif
#include <limits.h>
#endif

/* Return a integer or numeric scalar as approroate */

#define setflag(reg,flagval,val) (val?(reg |= flagval):(reg &= ~flagval))

Core PDL; /* Struct holding pointers to shared C routines */

#ifdef FOO
Core *pdl__Core_get_Core() /* INTERNAL TO CORE! DONT CALL FROM OUTSIDE */
{
	return PDL;
}
#endif

int pdl_debugging=0;
int pdl_autopthread_targ   = 0; /* No auto-pthreading unless set using the set_autopthread_targ */
int pdl_autopthread_actual = 0;
int pdl_autopthread_size   = 1;

#define CHECKP(p)    if ((p) == NULL) croak("Out of memory")

static PDL_Indx* pdl_packint( SV* sv, int *ndims ) {

   SV*  bar;
   AV*  array;
   int i;
   PDL_Indx *dims;

   if (!(SvROK(sv) && SvTYPE(SvRV(sv))==SVt_PVAV))  /* Test */
       return NULL;
   array = (AV *) SvRV(sv);   /* dereference */
     *ndims = (int) av_len(array) + 1;  /* Number of dimensions */
   /* Array space */
   dims = (PDL_Indx *) pdl_malloc( (*ndims) * sizeof(*dims) );
   CHECKP(dims);

   for(i=0; i<(*ndims); i++) {
      bar = *(av_fetch( array, i, 0 )); /* Fetch */
      dims[i] = (PDL_Indx) SvIV(bar);
   }
   return dims;
}

static SV* pdl_unpackint ( PDL_Indx *dims, int ndims ) {

   AV*  array;
   int i;

   array = newAV();

   for(i=0; i<ndims; i++) /* if ndims == 0, nothing stored -> ok */
         av_store( array, i, newSViv( (IV)dims[i] ) );

   return (SV*) array;
}

/*
 * Free the data if possible; used by mmapper
 * Moved from pdlhash.c July 10 2006 DJB
 */
static void pdl_freedata (pdl *a) {
	if(a->datasv) {
		SvREFCNT_dec(a->datasv);
		a->datasv=0;
		a->data=0;
	} else if(a->data) {
		die("Trying to free data of untouchable (mmapped?) pdl");
	}
}

#if BADVAL

#ifdef FOOFOO_PROPAGATE_BADFLAG

/*
 * this seems to cause an infinite loop in between tests 42 & 43 of
 * t/bad.t - ie
 *
 * $x = sequence( byte, 2, 3 );
 * $y = $x->slice("(1),:");
 * my $mask = sequence( byte, 2, 3 );
 * $mask = $mask->setbadif( ($mask % 3) == 2 );
 * print "a,b == ", $x->badflag, ",", $y->badflag, "\n";
 * $x->inplace->copybad( $mask );                          <-- think this is the call
 * print "a,b == ", $x->badflag, ",", $y->badflag, "\n";
 * print "$x $y\n";
 * ok( $y->badflag, 1 );
 *
 */

/* used by propagate_badflag() */

void propagate_badflag_children( pdl *it, int newval ) {
    PDL_DECL_CHILDLOOP(it)
    PDL_START_CHILDLOOP(it)
    {
	pdl_trans *trans = PDL_CHILDLOOP_THISCHILD(it);
	int i;

	for( i = trans->vtable->nparents;
	     i < trans->vtable->npdls;
	     i++ ) {

	    pdl *child = trans->pdls[i];

	    if ( newval ) child->state |=  PDL_BADVAL;
            else          child->state &= ~PDL_BADVAL;

	    /* make sure we propagate to grandchildren, etc */
	    propagate_badflag_children( child, newval );

        } /* for: i */
    }
    PDL_END_CHILDLOOP(it)
} /* propagate_badflag_children */

/* used by propagate_badflag() */

void propagate_badflag_parents( pdl *it ) {
    PDL_DECL_CHILDLOOP(it)
    PDL_START_CHILDLOOP(it)
    {
	pdl_trans *trans = PDL_CHILDLOOP_THISCHILD(it);
	int i;

	for( i = 0;
	     i < trans->vtable->nparents;
	     i++ ) {

	    pdl *parent = trans->pdls[i];

	    /* only sets allowed here */
	    parent->state |= PDL_BADVAL;

	    /* make sure we propagate to grandparents, etc */
	    propagate_badflag_parents( parent );

        } /* for: i */
    }
    PDL_END_CHILDLOOP(it)
} /* propagate_badflag_parents */

/*
 * we want to change the bad flag of the children
 * (newval = 1 means set flag, 0 means clear it).
 * If newval == 1, then we also loop through the
 * parents, setting their bad flag
 *
 * thanks to Christian Soeller for this
 */

void propagate_badflag( pdl *it, int newval ) {
   /* only do anything if the flag has changed - do we need this check ? */
   if ( newval ) {
      if ( (it->state & PDL_BADVAL) == 0 ) {
         propagate_badflag_parents( it );
         propagate_badflag_children( it, newval );
      }
   } else {
      if ( (it->state & PDL_BADVAL) > 0 ) {
         propagate_badflag_children( it, newval );
      }

   }

} /* propagate_badflag */

#else        /* FOOFOO_PROPAGATE_BADFLAG */

/* newval = 1 means set flag, 0 means clear it */
/* thanks to Christian Soeller for this */

void propagate_badflag( pdl *it, int newval ) {
    PDL_DECL_CHILDLOOP(it)
    PDL_START_CHILDLOOP(it)
    {
	pdl_trans *trans = PDL_CHILDLOOP_THISCHILD(it);
	int i;

	for( i = trans->vtable->nparents;
	     i < trans->vtable->npdls; i++ ) {

	    pdl *child = trans->pdls[i];

	    if ( newval ) child->state |=  PDL_BADVAL;
            else          child->state &= ~PDL_BADVAL;

	    /* make sure we propagate to grandchildren, etc */
	    propagate_badflag( child, newval );

        } /* for: i */
    }
    PDL_END_CHILDLOOP(it)
} /* propagate_badflag */

#endif    /* FOOFOO_PROPAGATE_BADFLAG */

void propagate_badvalue( pdl *it ) {
    PDL_DECL_CHILDLOOP(it)
    PDL_START_CHILDLOOP(it)
    {
	pdl_trans *trans = PDL_CHILDLOOP_THISCHILD(it);
	int i;

	for( i = trans->vtable->nparents;
	     i < trans->vtable->npdls; i++ ) {

	    pdl *child = trans->pdls[i];

            child->has_badvalue = 1;
            child->badvalue = it->badvalue;

	    /* make sure we propagate to grandchildren, etc */
	    propagate_badvalue( child );

        } /* for: i */
    }
    PDL_END_CHILDLOOP(it)
} /* propagate_badvalue */


/* this is horrible - the routines from bad should perhaps be here instead ? */
PDL_Anyval pdl_get_badvalue( int datatype ) {
    PDL_Anyval retval = { -1, 0 };
    switch ( datatype ) {

#include "pdldataswitch.c"

      default:
	croak("Unknown type sent to pdl_get_badvalue\n");
    }
    return retval;
} /* pdl_get_badvalue() */


PDL_Anyval pdl_get_pdl_badvalue( pdl *it ) {
    PDL_Anyval retval = { -1, 0 };
    int datatype;

#if BADVAL_PER_PDL
    if (it->has_badvalue) {
        retval = it->badvalue;
    } else {
        datatype = it->datatype;
        retval = pdl_get_badvalue( datatype );
    }
#else
    datatype = it->datatype;
    retval = pdl_get_badvalue( datatype );
#endif
    return retval;
} /* pdl_get_pdl_badvalue() */

#endif

#line 291 "Core.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 435 "Core.c"

XS_EUPXS(XS_PDL_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 291 "Core.xs"
    pdl *self;
#line 448 "Core.c"
#line 293 "Core.xs"
    if (  !(  (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVHV) )  ) {
       self = SvPDLV(sv);
       PDLDEBUG_f(printf("DESTROYING %p\n",(void*)self);)
       if (self != NULL)
          pdl_destroy(self);
    }
#line 456 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_get_trans); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_trans)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	SV *	RETVAL;
#line 306 "Core.xs"
	ST(0) = sv_newmortal();
	if(self->trans)  {
		sv_setref_pv(ST(0), "PDL::Trans", (void*)(self->trans));
	} else {
               ST(0) = &PL_sv_undef;
	}
#line 479 "Core.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_iscontig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_iscontig)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl*	x = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 320 "Core.xs"
      RETVAL = 1;
      pdl_make_physvaffine( x );
	if PDL_VAFFOK(x) {
	   int i;
           PDL_Indx inc=1;
	   PDLDEBUG_f(printf("vaff check...\n");)
  	   for (i=0;i<x->ndims;i++) {
     	      if (PDL_REPRINC(x,i) != inc) {
		     RETVAL = 0;
		     break;
              }
     	      inc *= x->dims[i];
  	   }
        }
#line 511 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE_COMMAND:  Including output of '/usr/bin/perl5.36.0 -e "require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()"' from 'Core.xs' */


XS_EUPXS(XS_PDL_allocated); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_allocated)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 5 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_ALLOCATED) > 0);
#line 535 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_anychgd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_anychgd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 13 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_ANYCHANGED) > 0);
#line 556 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_bflows); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_bflows)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 21 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_DATAFLOW_B) > 0);
#line 577 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_dimschgd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_dimschgd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 29 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_PARENTDIMSCHANGED) > 0);
#line 598 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_donttouch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_donttouch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 37 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_DONTTOUCHDATA) > 0);
#line 619 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_fflows); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_fflows)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 45 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_DATAFLOW_F) > 0);
#line 640 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_hdrcpy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_hdrcpy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x, mode=0");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	mode;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (int)SvIV(ST(1))
;
	}
#line 54 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        if (items>1)
           { setflag(x->state,PDL_HDRCPY,mode); }
        RETVAL = ((x->state & PDL_HDRCPY) > 0);
#line 671 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_is_inplace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_is_inplace)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x, mode=0");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	mode;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (int)SvIV(ST(1))
;
	}
#line 65 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((x->state & PDL_INPLACE) > 0);
        if (items>1)
           { setflag(x->state,PDL_INPLACE,mode); }
#line 702 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_tracedebug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_tracedebug)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x, mode=0");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	mode;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (int)SvIV(ST(1))
;
	}
#line 76 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        if (items>1)
           { setflag(x->state,PDL_TRACEDEBUG,mode); }
        RETVAL = ((x->state & PDL_TRACEDEBUG) > 0);
#line 733 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_vaffine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_vaffine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 86 "/usr/bin/perl5.36.0 -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_OPT_VAFFTRANSOK) > 0);
#line 754 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'Core.xs' from '/usr/bin/perl5.36.0 -e "require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()"' */

#if 0
#endif /* 0 - commented out */

XS_EUPXS(XS_PDL_set_inplace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_inplace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	val = (int)SvIV(ST(1))
;
#line 402 "Core.xs"
    setflag(self->state,PDL_INPLACE,val);
#line 780 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_address); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_address)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 408 "Core.xs"
    RETVAL = PTR2IV(self);
#line 799 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_pdl_hard_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_pdl_hard_copy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	pdl *	src = SvPDLV(ST(0))
;
	pdl *	RETVAL;

	RETVAL = pdl_hard_copy(src);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    SetSV_PDL(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_sever); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_sever)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	pdl *	src = SvPDLV(ST(0))
;
	pdl *	RETVAL;
#line 420 "Core.xs"
		if(src->trans) {
			pdl_make_physvaffine(src);
			pdl_destroytransform(src->trans,1);
		}
		RETVAL=src;
#line 846 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    SetSV_PDL(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_data_by_mmap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_data_by_mmap)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "it, fname, len, shared, writable, creat, mode, trunc");
    {
	pdl *	it = SvPDLV(ST(0))
;
	char *	fname = (char *)SvPV_nolen(ST(1))
;
	STRLEN	len = (STRLEN)SvUV(ST(2))
;
	int	writable = (int)SvIV(ST(4))
;
	int	shared = (int)SvIV(ST(3))
;
	int	creat = (int)SvIV(ST(5))
;
	int	mode = (int)SvIV(ST(6))
;
	int	trunc = (int)SvIV(ST(7))
;
	int	RETVAL;
	dXSTARG;
#line 439 "Core.xs"
#ifdef USE_MMAP
       int fd;
       pdl_freedata(it);
       fd = open(fname,(writable && shared ? O_RDWR : O_RDONLY)|
               (creat ? O_CREAT : 0),mode);
       if(fd < 0) {
               croak("Error opening file");
       }
       if(trunc) {
               int error = ftruncate(fd,0);   /* Clear all previous data */

               if(error)
               {
					fprintf(stderr,"Failed to set length of '%s' to %d. errno=%d",fname,(int)len,(int)error);
					croak("set_data_by_mmap: first ftruncate failed");
               }

               error = ftruncate(fd,len); /* And make it long enough */

               if(error)
               {
					fprintf(stderr,"Failed to set length of '%s' to %d. errno=%d",fname,(int)len,(int)error);
					croak("set_data_by_mmap: second ftruncate failed");
               }
       }
       if(len) {
		it->data = mmap(0,len,PROT_READ | (writable ?
					PROT_WRITE : 0),
				(shared ? MAP_SHARED : MAP_PRIVATE),
				fd,0);
		if(!it->data)
			croak("Error mmapping!");
       } else {
               /* Special case: zero-length file */
               it->data = NULL;
       }
       PDLDEBUG_f(printf("PDL::MMap: mapped to %p\n",it->data);)
       it->state |= PDL_DONTTOUCHDATA | PDL_ALLOCATED;
       pdl_add_deletedata_magic(it, pdl_delete_mmapped_data, len);
       close(fd);
#else
	croak("mmap not supported on this architecture");
#endif
       RETVAL = 1;
#line 928 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_state_and_add_deletedata_magic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_state_and_add_deletedata_magic)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "it, len");
    {
	pdl *	it = SvPDLV(ST(0))
;
	STRLEN	len = (STRLEN)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 491 "Core.xs"
            it->state |= PDL_DONTTOUCHDATA | PDL_ALLOCATED;
            pdl_add_deletedata_magic(it, pdl_delete_mmapped_data, len);
            RETVAL = 1;
#line 953 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_data_by_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_data_by_offset)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "it, orig, offset");
    {
	pdl *	it = SvPDLV(ST(0))
;
	pdl *	orig = SvPDLV(ST(1))
;
	STRLEN	offset = (STRLEN)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 503 "Core.xs"
              pdl_freedata(it);
              it->data = ((char *) orig->data) + offset;
	      it->datasv = orig->sv;
              (void)SvREFCNT_inc(it->datasv);
              it->state |= PDL_DONTTOUCHDATA | PDL_ALLOCATED;
              RETVAL = 1;
#line 983 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_nelem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_nelem)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = SvPDLV(ST(0))
;
	PDL_Indx	RETVAL;
	dXSTARG;
#line 516 "Core.xs"
		pdl_make_physdims(x);
		RETVAL = x->nvals;
#line 1005 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_howbig_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_howbig_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "datatype");
    {
	int	datatype = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 545 "Core.xs"
     RETVAL = pdl_howbig(datatype);
#line 1026 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_autopthread_targ); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_autopthread_targ)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 554 "Core.xs"
	RETVAL = i;
	pdl_autopthread_targ = i;
#line 1048 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_autopthread_targ); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_autopthread_targ)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 562 "Core.xs"
	RETVAL = pdl_autopthread_targ;
#line 1067 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_autopthread_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_autopthread_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 571 "Core.xs"
	RETVAL = i;
	pdl_autopthread_size = i;
#line 1089 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_autopthread_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_autopthread_size)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 579 "Core.xs"
	RETVAL = pdl_autopthread_size;
#line 1108 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_autopthread_actual); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_autopthread_actual)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 586 "Core.xs"
	RETVAL = pdl_autopthread_actual;
#line 1127 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_is_scalar_SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_is_scalar_SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "arg");
    {
	SV*	arg = ST(0)
;
	unsigned int	RETVAL;
	dXSTARG;
#line 596 "Core.xs"
	RETVAL = SvPOK(arg);
#line 1148 "Core.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_set_debugging); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_set_debugging)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 605 "Core.xs"
	RETVAL = pdl_debugging;
	pdl_debugging = i;
#line 1170 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_sclr_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_sclr_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "it");
    {
	pdl*	it = SvPDLV(ST(0))
;
#line 616 "Core.xs"
	PDL_Indx nullp = 0;
	PDL_Indx dummyd = 1;
	PDL_Indx dummyi = 1;
	PDL_Anyval result = { -1, 0 };
#line 1192 "Core.c"
	SV *	RETVAL;
#line 621 "Core.xs"
        /* get the first element of a piddle and return as
         * Perl scalar (autodetect suitable type IV or NV)
         */
        pdl_make_physvaffine( it );
	if (it->nvals < 1)
           croak("piddle must have at least one element");
	/* offs = PDL_REPROFFS(it); */
        /* result = pdl_get_offs(PDL_REPRP(it),offs); */
        result=pdl_at(PDL_REPRP(it), it->datatype, &nullp, &dummyd,
        &dummyi, PDL_REPROFFS(it),1);
        ANYVAL_TO_SV(RETVAL, result);

#line 1207 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_at_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_at_c)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, position");
    {
	pdl*	x = SvPDLV(ST(0))
;
	SV*	position = ST(1)
;
#line 642 "Core.xs"
    PDL_Indx * pos;
    int npos;
    int ipos;
    PDL_Anyval result = { -1, 0 };
#line 1231 "Core.c"
	SV *	RETVAL;
#line 647 "Core.xs"
    pdl_make_physvaffine( x );

    pos = pdl_packdims( position, &npos);

    if (pos == NULL || npos < x->ndims)
       croak("Invalid position");

    /*  allow additional trailing indices
     *  which must be all zero, i.e. a
     *  [3,1,5] piddle is treated as an [3,1,5,1,1,1,....]
     *  infinite dim piddle
     */
    for (ipos=x->ndims; ipos<npos; ipos++)
      if (pos[ipos] != 0)
         croak("Invalid position");

    result=pdl_at(PDL_REPRP(x), x->datatype, pos, x->dims,
        (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs), PDL_REPROFFS(x),
	x->ndims);

    ANYVAL_TO_SV(RETVAL, result);

#line 1256 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_at_bad_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_at_bad_c)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, position");
    {
	pdl*	x = SvPDLV(ST(0))
;
	SV *	position = ST(1)
;
#line 677 "Core.xs"
    PDL_Indx * pos;
    int npos;
    int ipos;
    int badflag;
    PDL_Anyval result = { -1, 0 };
#line 1281 "Core.c"
	SV *	RETVAL;
#line 683 "Core.xs"
    pdl_make_physvaffine( x );

    pos = pdl_packdims( position, &npos);

    if (pos == NULL || npos < x->ndims)
       croak("Invalid position");

    /*  allow additional trailing indices
     *  which must be all zero, i.e. a
     *  [3,1,5] piddle is treated as an [3,1,5,1,1,1,....]
     *  infinite dim piddle
     */
    for (ipos=x->ndims; ipos<npos; ipos++)
      if (pos[ipos] != 0)
         croak("Invalid position");

    result=pdl_at(PDL_REPRP(x), x->datatype, pos, x->dims,
        (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs), PDL_REPROFFS(x),
	x->ndims);
#if BADVAL
   badflag = (x->state & PDL_BADVAL) > 0;
#  if BADVAL_USENAN
   /* do we have to bother about NaN's? */
   if ( badflag &&
        ( ( x->datatype < PDL_F && ANYVAL_EQ_ANYVAL(result, pdl_get_badvalue(x->datatype)) ) ||
          ( x->datatype == PDL_CF && finite(result.value.C) == 0 ) ||
          ( x->datatype == PDL_CD && finite(result.value.G) == 0 ) ||
          ( x->datatype == PDL_F && finite(result.value.F) == 0 ) ||
          ( x->datatype == PDL_D && finite(result.value.D) == 0 )
        )
      ) {
	 RETVAL = newSVpvn( "BAD", 3 );
   } else
#  else
   if ( badflag &&
        ANYVAL_EQ_ANYVAL( result, pdl_get_badvalue( x->datatype ) )
      ) {
	 RETVAL = newSVpvn( "BAD", 3 );
   } else
#  endif
#endif

    ANYVAL_TO_SV(RETVAL, result);

#line 1328 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_list_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_list_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pdl *	x = SvPDLV(ST(0))
;
#line 735 "Core.xs"
	PDL_Indx *inds;
      PDL_Indx *incs;
      PDL_Indx offs;
	void *data;
	int ind;
	int stop = 0;
	SV *sv;
#line 1355 "Core.c"
#line 743 "Core.xs"
      pdl_make_physvaffine( x );
	inds = pdl_malloc(sizeof(PDL_Indx) * x->ndims); /* GCC -> on stack :( */

	data = PDL_REPRP(x);
	incs = (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs);
	offs = PDL_REPROFFS(x);
	EXTEND(sp,x->nvals);
	for(ind=0; ind < x->ndims; ind++) inds[ind] = 0;
	while(!stop) {
		PDL_Anyval pdl_val = { -1, 0 };
		pdl_val = pdl_at( data, x->datatype, inds, x->dims, incs, offs, x->ndims);
		ANYVAL_TO_SV(sv,pdl_val);
		PUSHs(sv_2mortal(sv));
		stop = 1;
		for(ind = 0; ind < x->ndims; ind++)
			if(++(inds[ind]) >= x->dims[ind])
				inds[ind] = 0;
			else
				{stop = 0; break;}
	}
#line 1377 "Core.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_PDL__Core_listref_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_listref_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = SvPDLV(ST(0))
;
#line 771 "Core.xs"
   PDL_Indx * inds;
   PDL_Indx * incs;
   PDL_Indx offs;
   void *data;
   int ind;
   int lind;
   int stop = 0;
   AV *av;
   SV *sv;
   PDL_Anyval pdl_val =    { -1, 0 };
   PDL_Anyval pdl_badval = { -1, 0 };
#line 1405 "Core.c"
	SV *	RETVAL;
#line 783 "Core.xs"
#if BADVAL
    /*
    */

   int badflag = (x->state & PDL_BADVAL) > 0;
#  if BADVAL_USENAN
    /* do we have to bother about NaN's? */
   if ( badflag && x->datatype < PDL_F ) {
      pdl_badval = pdl_get_pdl_badvalue( x );
   }
#  else
   if ( badflag ) {
      pdl_badval = pdl_get_pdl_badvalue( x );
   }
#  endif
#endif

   pdl_make_physvaffine( x );
   inds = pdl_malloc(sizeof(PDL_Indx) * x->ndims); /* GCC -> on stack :( */
   data = PDL_REPRP(x);
   incs = (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs);
   offs = PDL_REPROFFS(x);
   av = newAV();
   av_extend(av,x->nvals);
   lind=0;
   for(ind=0; ind < x->ndims; ind++) inds[ind] = 0;
   while(!stop) {
#if BADVAL
      pdl_val = pdl_at( data, x->datatype, inds, x->dims, incs, offs, x->ndims );
      if ( badflag && 
#  if BADVAL_USENAN
        ( (x->datatype < PDL_F && ANYVAL_EQ_ANYVAL(pdl_val, pdl_badval)) ||
          (x->datatype == PDL_F && finite(pdl_val.value.F) == 0) ||
          (x->datatype == PDL_D && finite(pdl_val.value.D) == 0) )
#  else
        ANYVAL_EQ_ANYVAL(pdl_val, pdl_badval)
#  endif
      ) {
	 sv = newSVpvn( "BAD", 3 );
      } else {
	 ANYVAL_TO_SV(sv, pdl_val);
      }
      av_store( av, lind, sv );
#else
      pdl_val = pdl_at( data, x->datatype, inds, x->dims, incs, offs, x->ndims );
      ANYVAL_TO_SV(sv, pdl_val);
      av_store(av, lind, sv);
#endif

      lind++;
      stop = 1;
      for(ind = 0; ind < x->ndims; ind++) {
	 if(++(inds[ind]) >= x->dims[ind]) {
       	    inds[ind] = 0;
         } else {
       	    stop = 0; break;
         }
      }
   }
   RETVAL = newRV_noinc((SV *)av);
#line 1468 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_set_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_set_c)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "x, position, value");
    {
	pdl*	x = SvPDLV(ST(0))
;
	SV*	position = ST(1)
;
	PDL_Anyval	value;
#line 855 "Core.xs"
    PDL_Indx * pos;
    int npos;
    int ipos;
#line 1492 "Core.c"

	if (!SvOK(ST(2))) {
		value.type = -1;
		value.value.B = 0;
	} else if (SvIOK(ST(2))) {
	#if IVSIZE == 8
		value.type = PDL_LL;
		value.value.Q = (PDL_LongLong) SvIV(ST(2));
	#else
		value.type = PDL_L;
		value.value.L = (PDL_Long) SvIV(ST(2));
	#endif
	} else {
		value.type = PDL_D;
		value.value.D = (PDL_Double) SvNV(ST(2));
	}
;
#line 859 "Core.xs"
    pdl_make_physvaffine( x );

    pos = pdl_packdims( position, &npos);
    if (pos == NULL || npos < x->ndims)
       croak("Invalid position");

    /*  allow additional trailing indices
     *  which must be all zero, i.e. a
     *  [3,1,5] piddle is treated as an [3,1,5,1,1,1,....]
     *  infinite dim piddle
     */
    for (ipos=x->ndims; ipos<npos; ipos++)
      if (pos[ipos] != 0)
         croak("Invalid position");

    pdl_children_changesoon( x , PDL_PARENTDATACHANGED );
    pdl_set(PDL_REPRP(x), x->datatype, pos, x->dims,
        (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs), PDL_REPROFFS(x),
	x->ndims,value);
    if (PDL_VAFFOK(x))
       pdl_vaffinechanged(x, PDL_PARENTDATACHANGED);
    else
       pdl_changed( x , PDL_PARENTDATACHANGED , 0 );
#line 1534 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL__Core_pdl_avref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_pdl_avref)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "array_ref, class, type");
    {
	SV*	array_ref = ST(0)
;
	char*	class = (char *)SvPV_nolen(ST(1))
;
	int	type = (int)SvIV(ST(2))
;
#line 970 "Core.xs"
     AV *dims, *av;
     int i, depth;
     int datalevel = -1;
     SV* psv;
     pdl* p;
#line 1559 "Core.c"
	SV *	RETVAL;
#line 976 "Core.xs"
     /* make a piddle from a Perl array ref */

     if (!SvROK(array_ref))
       croak("pdl_avref: not a reference");


     if (SvTYPE(SvRV(array_ref)) != SVt_PVAV)
       croak("pdl_avref: not an array reference");

     // Expand the array ref to a list, and allocate a Perl list to hold the dimlist
     av = (AV *) SvRV(array_ref);
     dims = (AV *) sv_2mortal( (SV *) newAV());

     av_store(dims,0,newSViv((IV) av_len(av)+1));

     /* even if we contain nothing depth is one */
     depth = 1 + av_ndcheck(av,dims,0,&datalevel);

     /* printf("will make type %s\n",class); */
     /*
	at this stage start making a piddle and populate it with
	values from the array (which has already been checked in av_check)
     */
     if (strcmp(class,"PDL") == 0) {
        p = pdl_from_array(av,dims,type,NULL); /* populate with data */
        ST(0) = sv_newmortal();
        SetSV_PDL(ST(0),p);
     } else {
       /* call class->initialize method */
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(class, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       psv = POPs;
       PUTBACK;
       p = SvPDLV(psv); /* and get piddle from returned object */
       ST(0) = psv;
       pdl_from_array(av,dims,type,p); /* populate ;) */
     }
#line 1602 "Core.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_pdl_null); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_pdl_null)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	pdl *	RETVAL;

	RETVAL = pdl_null();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    SetSV_PDL(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_pthreads_enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_pthreads_enabled)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = pdl_pthreads_enabled();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_isnull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_isnull)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 1038 "Core.xs"
		RETVAL= !!(self->state & PDL_NOMYDIMS);
#line 1660 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_make_physical); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_make_physical)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	pdl *	RETVAL;
#line 1046 "Core.xs"
		pdl_make_physical(self);
		RETVAL = self;
#line 1681 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    SetSV_PDL(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_make_physvaffine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_make_physvaffine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	pdl *	RETVAL;
#line 1055 "Core.xs"
		pdl_make_physvaffine(self);
		RETVAL = self;
#line 1706 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    SetSV_PDL(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_make_physdims); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_make_physdims)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	pdl *	RETVAL;
#line 1065 "Core.xs"
		pdl_make_physdims(self);
		RETVAL = self;
#line 1731 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    SetSV_PDL(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = SvPDLV(ST(0))
;

	pdl_dump(x);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_add_threading_magic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_add_threading_magic)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "it, nthdim, nthreads");
    {
	pdl *	it = SvPDLV(ST(0))
;
	int	nthdim = (int)SvIV(ST(1))
;
	int	nthreads = (int)SvIV(ST(2))
;

	pdl_add_threading_magic(it, nthdim, nthreads);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_remove_threading_magic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_remove_threading_magic)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "it");
    {
	pdl *	it = SvPDLV(ST(0))
;
#line 1084 "Core.xs"
		pdl_add_threading_magic(it,-1,-1);
#line 1790 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_initialize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_initialize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	class = ST(0)
;
#line 1092 "Core.xs"
	HV *bless_stash;
#line 1809 "Core.c"
	SV *	RETVAL;
#line 1094 "Core.xs"
        if (SvROK(class)) { /* a reference to a class */
	  bless_stash = SvSTASH(SvRV(class));
        } else {            /* a class name */
          bless_stash = gv_stashsv(class, 0);
        }
        ST(0) = sv_newmortal();
        SetSV_PDL(ST(0),pdl_null());   /* set a null PDL to this SV * */
        ST(0) = sv_bless(ST(0), bless_stash); /* bless appropriately  */
	XSRETURN(1);
#line 1821 "Core.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_PDL_get_dataref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_dataref)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	SV *	RETVAL;
#line 1108 "Core.xs"
	if(self->state & PDL_DONTTOUCHDATA) {
		croak("Trying to get dataref to magical (mmaped?) pdl");
	}
	pdl_make_physical(self); /* XXX IS THIS MEMLEAK WITHOUT MORTAL? */
	RETVAL = (newRV(self->datasv));
#line 1844 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_datatype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_datatype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 1120 "Core.xs"
	RETVAL = self->datatype;
#line 1865 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_upd_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_upd_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = SvPDLV(ST(0))
;
#line 1128 "Core.xs"
       STRLEN n_a;
#line 1884 "Core.c"
	int	RETVAL;
	dXSTARG;
#line 1130 "Core.xs"
	if(self->state & PDL_DONTTOUCHDATA) {
		croak("Trying to touch dataref of magical (mmaped?) pdl");
	}
       self->data = SvPV((SV*)self->datasv,n_a);
	XSRETURN(0);
#line 1893 "Core.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_dataflow_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_dataflow_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;
#line 1141 "Core.xs"
	if(value)
		self->state |= PDL_DATAFLOW_F;
	else
		self->state &= ~PDL_DATAFLOW_F;
#line 1915 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_set_dataflow_b); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_dataflow_b)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    {
	pdl *	self = SvPDLV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;
#line 1151 "Core.xs"
	if(value)
		self->state |= PDL_DATAFLOW_B;
	else
		self->state &= ~PDL_DATAFLOW_B;
#line 1937 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_getndims); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getndims)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 1162 "Core.xs"
		pdl_make_physdims(x);
		RETVAL = x->ndims;
#line 1958 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_getdim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getdim)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "x, y");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	y = (int)SvIV(ST(1))
;
	PDL_Indx	RETVAL;
	dXSTARG;
#line 1174 "Core.xs"
		pdl_make_physdims(x);
		if (y < 0) y = x->ndims + y;
		if (y < 0) croak("negative dim index too large");
		if (y < x->ndims)
                   RETVAL = x->dims[y];
                else
		   RETVAL = 1; /* return size 1 for all other dims */
#line 1988 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_getnthreadids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getnthreadids)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 1188 "Core.xs"
		pdl_make_physdims(x);
		RETVAL = x->nthreadids;
#line 2010 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_getthreadid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getthreadid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, y");
    {
	pdl *	x = SvPDLV(ST(0))
;
	int	y = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1198 "Core.xs"
		RETVAL = x->threadids[y];
#line 2033 "Core.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_setdims); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_setdims)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, dims_arg");
    {
	pdl *	x = SvPDLV(ST(0))
;
	SV *	dims_arg = ST(1)
;
#line 1207 "Core.xs"
	 PDL_Indx * dims;
	 int ndims;
       int i;
#line 2056 "Core.c"
#line 1211 "Core.xs"
	{
	        /* This mask avoids all kinds of subtle dereferencing bugs (CED 11/2015) */
	        if(x->trans || x->vafftrans || x->children.next ) {
		  pdl_barf("Can't setdims on a PDL that already has children");
		}

		/* not sure if this is still necessary with the mask above... (CED 11/2015)  */
		pdl_children_changesoon(x,PDL_PARENTDIMSCHANGED|PDL_PARENTDATACHANGED);
		dims = pdl_packdims(dims_arg,&ndims);
		pdl_reallocdims(x,ndims);
		for(i=0; i<ndims; i++) x->dims[i] = dims[i];
		pdl_resize_defaultincs(x);
		x->threadids[0] = ndims;
		x->state &= ~PDL_NOMYDIMS;
		pdl_changed(x,PDL_PARENTDIMSCHANGED|PDL_PARENTDATACHANGED,0);
	}
#line 2074 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_dowhenidle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_dowhenidle)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1231 "Core.xs"
		pdl_run_delayed_magic();
		XSRETURN(0);
#line 2090 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_bind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, c");
    {
	pdl *	p = SvPDLV(ST(0))
;
	SV *	c = ST(1)
;
#line 1240 "Core.xs"
		pdl_add_svmagic(p,c);
		XSRETURN(0);
#line 2110 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_sethdr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_sethdr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, h");
    {
	pdl *	p = SvPDLV(ST(0))
;
	SV *	h = ST(1)
;
#line 1248 "Core.xs"
	HV* hash;
#line 2129 "Core.c"
#line 1250 "Core.xs"
		if(p->hdrsv == NULL) {
		      p->hdrsv =  &PL_sv_undef; /*(void*) newSViv(0);*/
		}

		/* Throw an error if we're not either undef or hash */
                if ( (h != &PL_sv_undef && h != NULL) &&
		     ( !SvROK(h) || SvTYPE(SvRV(h)) != SVt_PVHV )
		   )
		      croak("Not a HASH reference");

		/* Clear the old header */
		SvREFCNT_dec(p->hdrsv);

		/* Put the new header (or undef) in place */
		if(h == &PL_sv_undef || h == NULL)
		   p->hdrsv = NULL;
		else
		   p->hdrsv = (void*) newRV( (SV*) SvRV(h) );
#line 2149 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_hdr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_hdr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	pdl *	p = SvPDLV(ST(0))
;
	SV *	RETVAL;
#line 1273 "Core.xs"
		pdl_make_physdims(p);

                /* Make sure that in the undef case we return not */
                /* undef but an empty hash ref. */

                if((p->hdrsv==NULL) || (p->hdrsv == &PL_sv_undef)) {
	            p->hdrsv = (void*) newRV_noinc( (SV*)newHV() );
                }

		RETVAL = newRV( (SV*) SvRV((SV*)p->hdrsv) );

#line 2177 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_gethdr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_gethdr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	pdl *	p = SvPDLV(ST(0))
;
	SV *	RETVAL;
#line 1295 "Core.xs"
		pdl_make_physdims(p);

                if((p->hdrsv==NULL) || (p->hdrsv == &PL_sv_undef)) {
	            RETVAL = &PL_sv_undef;
                } else {
		    RETVAL = newRV( (SV*) SvRV((SV*)p->hdrsv) );
                }

#line 2204 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_datatype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_datatype)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, datatype");
    {
	pdl *	a = SvPDLV(ST(0))
;
	int	datatype = (int)SvIV(ST(1))
;
#line 1311 "Core.xs"
    pdl_make_physical(a);
    if(a->trans)
	    pdl_destroytransform(a->trans,1);
/*     if(! (a->state && PDL_NOMYDIMS)) { */
    pdl_converttype( &a, datatype, PDL_PERM );
/*     } */
#line 2230 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_threadover_n); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_threadover_n)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 1321 "Core.xs"
   int npdls;
   SV *sv;
#line 2246 "Core.c"
#line 1324 "Core.xs"
   {
    npdls = items - 1;
    if(npdls <= 0)
    	croak("Usage: threadover_n(pdl[,pdl...],sub)");
    {
	    int i,sd;
	    pdl **pdls = malloc(sizeof(pdl *) * npdls);
	    PDL_Indx *realdims = malloc(sizeof(PDL_Indx) * npdls);
	    pdl_thread pdl_thr;
	    SV *code = ST(items-1);
	    for(i=0; i<npdls; i++) {
		pdls[i] = SvPDLV(ST(i));
		/* XXXXXXXX Bad */
		pdl_make_physical(pdls[i]);
		realdims[i] = 0;
	    }
	    PDL_THR_CLRMAGIC(&pdl_thr);
	    pdl_initthreadstruct(0,pdls,realdims,realdims,npdls,NULL,&pdl_thr,NULL, 1);
	    pdl_startthreadloop(&pdl_thr,NULL,NULL);
	    sd = pdl_thr.ndims;
	    do {
	    	dSP;
		PUSHMARK(sp);
		EXTEND(sp,items);
		PUSHs(sv_2mortal(newSViv((sd-1))));
		for(i=0; i<npdls; i++) {
			PDL_Anyval pdl_val = { -1, 0 };
			pdl_val = pdl_get_offs(pdls[i],pdl_thr.offs[i]);
			ANYVAL_TO_SV(sv, pdl_val);
			PUSHs(sv_2mortal(sv));
		}
	    	PUTBACK;
		perl_call_sv(code,G_DISCARD);
	    } while( (sd = pdl_iterthreadloop(&pdl_thr,0)) );
	    pdl_freethreadloop(&pdl_thr);
	    free(pdls);
	    free(realdims);
    }
   }
#line 2287 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_threadover); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_threadover)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 1367 "Core.xs"
    int npdls;
    int targs;
    int nothers = -1;
#line 2304 "Core.c"
#line 1371 "Core.xs"
   {
        targs = items - 4;
    if (items > 0) nothers = SvIV(ST(0));
    if(targs <= 0 || nothers < 0 || nothers >= targs)
    	croak("Usage: threadover(nothers,pdl[,pdl...][,otherpars..],realdims,creating,sub)");
    npdls = targs-nothers;
    {
	    int i,nd1,nd2,dtype=0;
	    PDL_Indx j,nc=npdls;
	    SV* rdimslist = ST(items-3);
	    SV* cdimslist = ST(items-2);
	    SV *code = ST(items-1);
	    pdl_thread pdl_thr;
	    pdl **pdls = malloc(sizeof(pdl *) * npdls);
	    pdl **child = malloc(sizeof(pdl *) * npdls);
	    SV **csv = malloc(sizeof(SV *) * npdls);
	    SV **dims = malloc(sizeof(SV *) * npdls);
	    SV **incs = malloc(sizeof(SV *) * npdls);
	    SV **others = malloc(sizeof(SV *) * nothers);
	    PDL_Indx *creating = pdl_packint(cdimslist,&nd2);
	    PDL_Indx *realdims = pdl_packint(rdimslist,&nd1);
	    CHECKP(pdls); CHECKP(child); CHECKP(dims);
	    CHECKP(incs); CHECKP(csv);

	    if (nd1 != npdls || nd2 < npdls)
		croak("threadover: need one realdim and creating flag "
		      "per pdl!");
	    for(i=0; i<npdls; i++) {
		pdls[i] = SvPDLV(ST(i+1));
		if (creating[i])
		  nc += realdims[i];
		else {
		  pdl_make_physical(pdls[i]); /* is this what we want?XXX */
		  dtype = PDLMAX(dtype,pdls[i]->datatype);
		}
	    }
	    for (i=npdls+1; i<=targs; i++)
		others[i-npdls-1] = ST(i);
	    if (nd2 < nc)
		croak("Not enough dimension info to create pdls");
#ifdef DEBUG_PTHREAD
		for (i=0;i<npdls;i++) { /* just for debugging purposes */
		printf("pdl %d Dims: [",i);
		for (j=0;j<realdims[i];j++)
			printf("%d ",pdls[i]->dims[j]);
		printf("] Incs: [");
		for (j=0;j<realdims[i];j++)
			printf("%d ",PDL_REPRINC(pdls[i],j));
		printf("]\n");
	        }
#endif
	    PDL_THR_CLRMAGIC(&pdl_thr);
	    pdl_initthreadstruct(0,pdls,realdims,creating,npdls,
				NULL,&pdl_thr,NULL, 1);
	    for(i=0, nc=npdls; i<npdls; i++)  /* create as necessary */
              if (creating[i]) {
		PDL_Indx *cp = creating+nc;
		pdls[i]->datatype = dtype;
		pdl_thread_create_parameter(&pdl_thr,i,cp,0);
		nc += realdims[i];
		pdl_make_physical(pdls[i]);
		PDLDEBUG_f(pdl_dump(pdls[i]));
		/* And make it nonnull, now that we've created it */
		pdls[i]->state &= (~PDL_NOMYDIMS);
	      }
	    pdl_startthreadloop(&pdl_thr,NULL,NULL);
	    for(i=0; i<npdls; i++) { /* will the SV*'s be properly freed? */
		dims[i] = newRV(pdl_unpackint(pdls[i]->dims,realdims[i]));
		incs[i] = newRV(pdl_unpackint(PDL_VAFFOK(pdls[i]) ?
		pdls[i]->vafftrans->incs: pdls[i]->dimincs,realdims[i]));
		/* need to make sure we get the vaffine (grand)parent */
		if (PDL_VAFFOK(pdls[i]))
		   pdls[i] = pdls[i]->vafftrans->from;
		child[i]=pdl_null();
		/*  instead of pdls[i] its vaffine parent !!!XXX */
		PDL.affine_new(pdls[i],child[i],pdl_thr.offs[i],dims[i],
						incs[i]);
		pdl_make_physical(child[i]); /* make sure we can get at
						the vafftrans          */
		csv[i] = sv_newmortal();
		SetSV_PDL(csv[i], child[i]); /* pdl* into SV* */
	    }
	    do {  /* the actual threadloop */
		pdl_trans_affine *traff;
	    	dSP;
		PUSHMARK(sp);
		EXTEND(sp,npdls);
		for(i=0; i<npdls; i++) {
		   /* just twiddle the offset - quick and dirty */
		   /* we must twiddle both !! */
		   traff = (pdl_trans_affine *) child[i]->trans;
		   traff->offs = pdl_thr.offs[i];
		   child[i]->vafftrans->offs = pdl_thr.offs[i];
		   child[i]->state |= PDL_PARENTDATACHANGED;
		   PUSHs(csv[i]);
		}
		for (i=0; i<nothers; i++)
		  PUSHs(others[i]);   /* pass the OtherArgs onto the stack */
	    	PUTBACK;
		perl_call_sv(code,G_DISCARD);
	    } while (pdl_iterthreadloop(&pdl_thr,0));
	    pdl_freethreadloop(&pdl_thr);
	    free(pdls);  /* should all these be done with pdl_malloc */
	    free(dims);  /* in case the sub barfs ? XXXX            */
	    free(child);
	    free(csv);
	    free(incs);
	    free(others);
    }
   }
#line 2416 "Core.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_PDL__Core); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_PDL__Core)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("PDL::DESTROY", XS_PDL_DESTROY);
        newXS_deffile("PDL::get_trans", XS_PDL_get_trans);
        newXS_deffile("PDL::iscontig", XS_PDL_iscontig);
        newXS_deffile("PDL::allocated", XS_PDL_allocated);
        newXS_deffile("PDL::anychgd", XS_PDL_anychgd);
        newXS_deffile("PDL::bflows", XS_PDL_bflows);
        newXS_deffile("PDL::dimschgd", XS_PDL_dimschgd);
        newXS_deffile("PDL::donttouch", XS_PDL_donttouch);
        newXS_deffile("PDL::fflows", XS_PDL_fflows);
        newXS_deffile("PDL::hdrcpy", XS_PDL_hdrcpy);
        newXS_deffile("PDL::is_inplace", XS_PDL_is_inplace);
        newXS_deffile("PDL::tracedebug", XS_PDL_tracedebug);
        newXS_deffile("PDL::vaffine", XS_PDL_vaffine);
        newXS_deffile("PDL::set_inplace", XS_PDL_set_inplace);
        newXS_deffile("PDL::address", XS_PDL_address);
        newXS_deffile("PDL::pdl_hard_copy", XS_PDL_pdl_hard_copy);
        newXS_deffile("PDL::sever", XS_PDL_sever);
        newXS_deffile("PDL::set_data_by_mmap", XS_PDL_set_data_by_mmap);
        newXS_deffile("PDL::set_state_and_add_deletedata_magic", XS_PDL_set_state_and_add_deletedata_magic);
        newXS_deffile("PDL::set_data_by_offset", XS_PDL_set_data_by_offset);
        newXS_deffile("PDL::nelem", XS_PDL_nelem);
        newXS_deffile("PDL::howbig_c", XS_PDL_howbig_c);
        newXS_deffile("PDL::set_autopthread_targ", XS_PDL_set_autopthread_targ);
        newXS_deffile("PDL::get_autopthread_targ", XS_PDL_get_autopthread_targ);
        newXS_deffile("PDL::set_autopthread_size", XS_PDL_set_autopthread_size);
        newXS_deffile("PDL::get_autopthread_size", XS_PDL_get_autopthread_size);
        newXS_deffile("PDL::get_autopthread_actual", XS_PDL_get_autopthread_actual);
        newXS_deffile("PDL::Core::is_scalar_SvPOK", XS_PDL__Core_is_scalar_SvPOK);
        newXS_deffile("PDL::Core::set_debugging", XS_PDL__Core_set_debugging);
        newXS_deffile("PDL::Core::sclr_c", XS_PDL__Core_sclr_c);
        newXS_deffile("PDL::Core::at_c", XS_PDL__Core_at_c);
        newXS_deffile("PDL::Core::at_bad_c", XS_PDL__Core_at_bad_c);
        newXS_deffile("PDL::Core::list_c", XS_PDL__Core_list_c);
        newXS_deffile("PDL::Core::listref_c", XS_PDL__Core_listref_c);
        newXS_deffile("PDL::Core::set_c", XS_PDL__Core_set_c);
        newXS_deffile("PDL::Core::pdl_avref", XS_PDL__Core_pdl_avref);
        newXS_deffile("PDL::pdl_null", XS_PDL_pdl_null);
        newXS_deffile("PDL::Core::pthreads_enabled", XS_PDL__Core_pthreads_enabled);
        newXS_deffile("PDL::isnull", XS_PDL_isnull);
        newXS_deffile("PDL::make_physical", XS_PDL_make_physical);
        newXS_deffile("PDL::make_physvaffine", XS_PDL_make_physvaffine);
        newXS_deffile("PDL::make_physdims", XS_PDL_make_physdims);
        newXS_deffile("PDL::dump", XS_PDL_dump);
        newXS_deffile("PDL::add_threading_magic", XS_PDL_add_threading_magic);
        newXS_deffile("PDL::remove_threading_magic", XS_PDL_remove_threading_magic);
        newXS_deffile("PDL::initialize", XS_PDL_initialize);
        newXS_deffile("PDL::get_dataref", XS_PDL_get_dataref);
        newXS_deffile("PDL::get_datatype", XS_PDL_get_datatype);
        newXS_deffile("PDL::upd_data", XS_PDL_upd_data);
        newXS_deffile("PDL::set_dataflow_f", XS_PDL_set_dataflow_f);
        newXS_deffile("PDL::set_dataflow_b", XS_PDL_set_dataflow_b);
        cv = newXS_deffile("PDL::getndims", XS_PDL_getndims);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("PDL::ndims", XS_PDL_getndims);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("PDL::dim", XS_PDL_getdim);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("PDL::getdim", XS_PDL_getdim);
        XSANY.any_i32 = 0;
        newXS_deffile("PDL::getnthreadids", XS_PDL_getnthreadids);
        newXS_deffile("PDL::getthreadid", XS_PDL_getthreadid);
        newXS_deffile("PDL::setdims", XS_PDL_setdims);
        newXS_deffile("PDL::dowhenidle", XS_PDL_dowhenidle);
        (void)newXSproto_portable("PDL::bind", XS_PDL_bind, file, "$&");
        newXS_deffile("PDL::sethdr", XS_PDL_sethdr);
        newXS_deffile("PDL::hdr", XS_PDL_hdr);
        newXS_deffile("PDL::gethdr", XS_PDL_gethdr);
        newXS_deffile("PDL::set_datatype", XS_PDL_set_datatype);
        newXS_deffile("PDL::threadover_n", XS_PDL_threadover_n);
        newXS_deffile("PDL::threadover", XS_PDL_threadover);

    /* Initialisation Section */

#line 884 "Core.xs"
{
#if NVSIZE > 8
   fprintf(stderr, "Your perl NV has more precision than PDL_Double.  There will be loss of floating point precision!\n");
#endif

   /* Initialize structure of pointers to core C routines */

   PDL.Version     = PDL_CORE_VERSION;
   PDL.SvPDLV      = SvPDLV;
   PDL.SetSV_PDL   = SetSV_PDL;
   PDL.create      = pdl_create;
   PDL.pdlnew      = pdl_external_new;
   PDL.tmp         = pdl_external_tmp;
   PDL.destroy     = pdl_destroy;
   PDL.null        = pdl_null;
   PDL.copy        = pdl_copy;
   PDL.hard_copy   = pdl_hard_copy;
   PDL.converttype = pdl_converttype;
   PDL.twod        = pdl_twod;
   PDL.smalloc     = pdl_malloc;
   PDL.howbig      = pdl_howbig;
   PDL.packdims    = pdl_packdims;
   PDL.unpackdims  = pdl_unpackdims;
   PDL.setdims     = pdl_setdims;
   PDL.grow        = pdl_grow;
   PDL.flushcache  = NULL;
   PDL.reallocdims = pdl_reallocdims;
   PDL.reallocthreadids = pdl_reallocthreadids;
   PDL.resize_defaultincs = pdl_resize_defaultincs;
   PDL.get_threadoffsp = pdl_get_threadoffsp;
   PDL.thread_copy = pdl_thread_copy;
   PDL.clearthreadstruct = pdl_clearthreadstruct;
   PDL.initthreadstruct = pdl_initthreadstruct;
   PDL.startthreadloop = pdl_startthreadloop;
   PDL.iterthreadloop = pdl_iterthreadloop;
   PDL.freethreadloop = pdl_freethreadloop;
   PDL.thread_create_parameter = pdl_thread_create_parameter;
   PDL.add_deletedata_magic = pdl_add_deletedata_magic;

   PDL.setdims_careful = pdl_setdims_careful;
   PDL.put_offs = pdl_put_offs;
   PDL.get_offs = pdl_get_offs;
   PDL.get = pdl_get;
   PDL.set_trans_childtrans = pdl_set_trans_childtrans;
   PDL.set_trans_parenttrans = pdl_set_trans_parenttrans;

   PDL.get_convertedpdl = pdl_get_convertedpdl;

   PDL.make_trans_mutual = pdl_make_trans_mutual;
   PDL.trans_mallocfreeproc = pdl_trans_mallocfreeproc;
   PDL.make_physical = pdl_make_physical;
   PDL.make_physdims = pdl_make_physdims;
   PDL.make_physvaffine = pdl_make_physvaffine;
   PDL.pdl_barf      = pdl_barf;
   PDL.pdl_warn      = pdl_warn;
   PDL.allocdata     = pdl_allocdata;
   PDL.safe_indterm  = pdl_safe_indterm;
   PDL.children_changesoon = pdl_children_changesoon;
   PDL.changed       = pdl_changed;
   PDL.vaffinechanged = pdl_vaffinechanged;

   PDL.NaN_float  = union_nan_float.f;
   PDL.NaN_double = union_nan_double.d;
#if BADVAL
   PDL.propagate_badflag = propagate_badflag;
   PDL.propagate_badvalue = propagate_badvalue;
   PDL.get_pdl_badvalue = pdl_get_pdl_badvalue;
#include "pdlbadvalinit.c"
#endif
   /*
      "Publish" pointer to this structure in perl variable for use
       by other modules
   */
   sv_setiv(get_sv("PDL::SHARE",TRUE|GV_ADDMULTI), PTR2IV(&PDL));
}

#line 2599 "Core.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

